const merge = require('merge');

module.exports = {
    extends: 'osedea/core',

    parser: 'babel-eslint',

    env: {
        es6: true,
    },

    parserOptions: {
        ecmaVersion: 2019,
        sourceType: 'module',
    },

    plugins: [
        'babel',
        'promise',
        // 'sort-class-members',
        'import',
    ],

    settings: {
        'import/ignore': ['node_modules', '\\.s?css'],
    },

    rules: merge(
        require('./lib/rules/core-ecmascript-6'),
        require('./lib/rules/promise'),
        require('./lib/rules/babel'),
        // require('./lib/rules/sort-class-members'),
        require('./lib/rules/import')
    ),
};
