// ----------------------------------------------------------------------------
// Babel
// https://github.com/babel/eslint-plugin-babel
// ----------------------------------------------------------------------------

module.exports = {
    // Ignores capitalized decorators (@Decorator)
    'new-cap': 'off',
    'babel/new-cap': ['error', { newIsCap: true, capIsNew: false }],

    // doesn't complain about optional chaining (var foo = bar?.a_b;`)
    camelcase: 'off',
    'babel/camelcase': ['error', { properties: 'always', ignoreDestructuring: false }], // allow: ['^UNSAFE_']

    // doesn't fail when inside class properties (`class A { a = this.b; }`)
    'no-invalid-this': 'off',
    'babel/no-invalid-this': 'error',

    // doesn't complain about export x from "mod"; or export * as x from "mod";
    'object-curly-spacing': 'off',
    'babel/object-curly-spacing': ['error', 'always'],

    // doesn't complain about JSX fragment shorthand syntax
    quotes: 'off',
    'babel/quotes': ['error', 'single', { avoidEscape: true, allowTemplateLiterals: true }],

    // doesn't fail when using for await (let something of {}). Includes class properties
    semi: 'off',
    'babel/semi': 'error',

    // doesn't fail when using do expressions
    'no-unused-expressions': 'off',
    'babel/no-unused-expressions': 'off',

    // doesn't complain when used with BigInt (typeof BigInt(9007199254740991) === 'bigint')
    'valid-typeof': 'off',
    'babel/valid-typeof': 'error',
};
