// ----------------------------------------------------------------------------
// React Native a11y
// https://github.com/FormidableLabs/eslint-plugin-react-native-a11y
// ----------------------------------------------------------------------------

module.exports = {
    // Enforce that views that have accessible={true}, also have an accessibilityLabel prop
    'react-native-a11y/accessibility-label': 'error',

    // Enforce all <Touchable\*> components have accessibilityRole prop or both accessibilityTraits and accessibilityComponentType props set
    'react-native-a11y/has-accessibility-props': 'error',

    // Enforce accessibilityRole property value is valid
    'react-native-a11y/has-valid-accessibility-role': 'error',

    // Enforce accessibilityStates property value is valid
    'react-native-a11y/has-valid-accessibility-states': 'error',

    // Enforce accessibilityComponentType property value is valid
    'react-native-a11y/has-valid-accessibility-component-type': 'error', // TODO accessibilityComponentType will be deprecated

    // Enforce accessibilityTraits and accessibilityComponentType prop values must be valid
    'react-native-a11y/has-valid-accessibility-traits': 'error', // TODO accessibilityTraits will be deprecated

    // Enforce accessibilityLiveRegion prop values must be valid
    'react-native-a11y/has-valid-accessibility-live-region': 'error',

    // Enforce importantForAccessibility property value is valid
    'react-native-a11y/has-valid-important-for-accessibility': 'error',

    // Enforce if a view has accessible={true}, that there are no touchable elements inside
    'react-native-a11y/no-nested-touchables': 'error',
};
