const merge = require('merge');

module.exports = {
    env: {
        'react-native/react-native': true,
    },

    extends: ['osedea/react'],

    plugins: ['react-native', 'react-native-a11y', 'import'],

    // https://github.com/benmosher/eslint-plugin-import/blob/master/config/react-native.js
    // settings:
    //   import/resolver:
    //     node:
    //       // Note: will not complain if only _one_ of these files exists.
    //       extensions:
    //         - '.js'
    //         - '.web.js'
    //         - '.ios.js'
    //         - '.android.js'

    settings: {
        'import/resolver': 'reactnative',
    },

    rules: merge(require('./lib/rules/react-native'), require('./lib/rules/react-native-a11y'), {
        // Forbid foreign propTypes
        // Since RN doesn't remove proptypes, not necessary to use this
        'react/forbid-foreign-prop-types': 'off',
    }),
};
