const merge = require('merge');

module.exports = {
    extends: [
        'osedea/esnext',
        // 'osedea/import',
    ],

    plugins: ['react', 'jsx-a11y', 'react-hooks'],

    parserOptions: {
        ecmaFeatures: {
            jsx: true,
        },
    },

    // https://github.com/benmosher/eslint-plugin-import/blob/master/config/react.js
    // settings:
    //   import/extensions:
    //     - '.js'
    //     - '.jsx'

    // settings:
    //     import/resolver: webpack
    //     import/extensions:
    //         - '.js'
    //         - '.jsx'

    rules: merge(
        require('./lib/rules/react'),
        require('./lib/rules/react-hooks'),
        require('./lib/rules/jsx-a11y'),
        {
            'consistent-return': 'off',
            'class-methods-use-this': [ // TODO
                'warn',
                {
                    exceptMethods: [
                        'render',
                        'getInitialState',
                        'getDefaultProps',
                        'getChildContext',
                        'componentWillMount',
                        'UNSAFE_componentWillMount',
                        'componentDidMount',
                        'componentWillReceiveProps',
                        'UNSAFE_componentWillReceiveProps',
                        'shouldComponentUpdate',
                        'componentWillUpdate',
                        'UNSAFE_componentWillUpdate',
                        'componentDidUpdate',
                        'componentWillUnmount',
                        'componentDidCatch',
                        'getSnapshotBeforeUpdate',
                    ],
                },
            ],
        }
    ),

    overrides: [
        {
            files: ['*.ts', '*.tsx'],
            rules: require('./lib/rules/react-typescript'),
        },
    ],
};
